#ifndef _fencer_drop_h
#define _fencer_drop_h

typedef struct {
    void (*const drop)(void* self);
} IDrop;

typedef struct {
    void const* data;
    IDrop const* tc;
} Drop;

#define impl_Drop_for(T, drop_f)\
static inline Drop T##_as_Drop(T* x) {\
    TC_FN_TYPECHECK(void, drop_f, T*);\
    static IDrop const tc = {\
        .drop = (void(*const)(void*)) drop_f,\
    };\
    return (Drop){.tc = &tc, .data = x};\
}

#define impl_default_Drop_for(T)\
    static void default_drop_##T(T* v) { free(v); }\
    impl_Drop_for(T, default_drop_##T)

#endif // !_fencer_drop_h
